<script setup lang="ts">
import { AiVulnerabilityResolution, ValuesThree, Eye } from 'slippers-ui/icons';
import { ref } from 'vue';

interface AccordionItem {
  header: string;
  content: string;
  config?: {
    icon?: string;
  };
}
interface AccordionAndTextCol {
  textBlock: {
    header: string;
    content: string;
  };
  accordion: Array<AccordionItem>;
  config?: {
    theme?: string;
    id?: string;
  };
}

defineProps<AccordionAndTextCol>();
const isOpenIndex = ref<number | null>(0);
const toggleController = (index: number) => {
  isOpenIndex.value = isOpenIndex.value === index ? null : index;
};
//Icons
const icons: Component = { AiVulnerabilityResolution, ValuesThree, Eye };
</script>

<template>
  <section
    :id="config?.id"
    class="accordion-and-text-col slp-py-48 slp-py-md-96"
    :class="`accordion-and-text-col--${config?.theme}`"
  >
    <SlpContainer>
      <SlpRow class="recognition__row">
        <SlpColumn :cols="6" size="lg">
          <div class="slp-mb-16 slp-mb-md-32">
            <SlpTypography tag="h2" variant="heading2-bold" class="slp-mb-8">
              <span>{{ textBlock.header }}</span>
            </SlpTypography>
            <SlpTypography tag="h2" variant="body1" class="slp-mb-32 accordion-and-text-col__description">
              <span>{{ textBlock.content }}</span>
            </SlpTypography>
          </div>
        </SlpColumn>
        <SlpColumn class="slp-pl-md-16">
          <CommonAccordion
            v-for="(item, index) in accordion"
            :key="item.header"
            :data="item"
            :is-open="isOpenIndex == index"
            @toggle-controller="toggleController(index)"
          >
            <template #header>
              <SlpIcon v-if="item.config?.icon" :icon="icons[item.config?.icon]" size="lg" class="slp-mr-16" />
              <span class="accordion-title">{{ item.header }}</span>
            </template>
          </CommonAccordion>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.accordion-and-text-col {
  &__description {
    max-width: 550px;
  }
  &--dark {
    background-color: $color-primary-200;
    color: #fff;
    .accordion-and-text-col__description {
      color: $color-surface-400;
    }
    :deep(.accordion) {
      color: currentColor;
      .accordion__icon {
        &:before,
        &:after {
          background-color: currentColor;
        }
      }
      .accordion-and-text-col__description,
      .content {
        color: $color-surface-400;
      }
      .accordion__summary {
        border-top: 1px solid #45424d;
        padding-bottom: 20px;
        padding-top: 16px;
        align-items: center;
        cursor: pointer;
        display: flex;
        justify-content: space-between;
      }
      .accordion-title {
        flex: 1;
        font-weight: 600;
      }
      .content {
        padding: 0 0 32px;
        p {
          margin-bottom: 16px;
        }
      }
    }
  }
}
</style>
